import InternalModelMap from './internal-model-map';
/**
 `IdentityMap` is a custom storage map for records by modelName
 used by `DS.Store`.

 @class IdentityMap
 @private
 */
export default class IdentityMap {
    private _map;
    /**
     Retrieves the `InternalModelMap` for a given modelName,
     creating one if one did not already exist. This is
     similar to `getWithDefault` or `get` on a `MapWithDefault`
  
     @method retrieve
     @param modelName a previously normalized modelName
     @return {InternalModelMap} the InternalModelMap for the given modelName
     */
    retrieve(modelName: string): InternalModelMap;
    /**
     Clears the contents of all known `RecordMaps`, but does
     not remove the InternalModelMap instances.
  
     @method clear
     */
    clear(): void;
}
